##- Nanar <nanardon@mandrake.org>
##-
##- This program is free software; you can redistribute it and/or modify
##- it under the terms of the GNU General Public License as published by
##- the Free Software Foundation; either version 2, or (at your option)
##- any later version.
##-
##- This program is distributed in the hope that it will be useful,
##- but WITHOUT ANY WARRANTY; without even the implied warranty of
##- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##- GNU General Public License for more details.
##-
##- You should have received a copy of the GNU General Public License
##- along with this program; if not, write to the Free Software
##- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Header.pm,v 1.6 2004/08/03 12:48:56 othauvin Exp $

package Hdlist::Header;

use strict;
use warnings;

use Hdlist;

sub dep2synt {
    my ($header, $fmt) = @_;
    my @dep = split("\n", $header->queryformat($fmt));
    @dep = map { s/\[= /[== /; s/\[ \]//g; $_ } grep { !m/rpmlib\(/ && !m/\(none\)/ && length } @dep;
    @dep
}


sub writesynthesis {
    my ($header, $handle, $filetoprovides) = @_;
    $handle ||= *STDOUT;
    
    my %filestoput;
    foreach (@$filetoprovides, split("\n", $header->queryformat("[%{FILENAMES}\\n]"))) {
            $filestoput{$_}++;
    }
    my @pkgfiles = map { $_ = "$_\[*\]"; } grep { $filestoput{$_} == 2 } keys(%filestoput);
    
    foreach my $deptag (qw(PROVIDE CONFLICT OBSOLETE REQUIRE)) {
        my (@dep) = $header->dep2synt("[%{${deptag}NAME}\\[%{${deptag}FLAGS:depflags} %{${deptag}VERSION}\\]\\n]");
        $deptag eq 'PROVIDE' and push(@dep, @pkgfiles);
        { my %uniq; $uniq{$_} = 1 foreach(@dep); @dep = keys(%uniq); }
        my $t = join('@', @dep);
        printf($handle '@%ss@%s'."\n", lc($deptag), $t) if($t);
    }
    
    printf($handle '@summary@%s'. "\n",
        $header->tag(1004),
    );
    printf($handle '@info@%s@%d@%d@%s'."\n",
        scalar($header->fullname()),
        $header->tag(1003) || 0, # Epoch
        $header->tag(1009), # rpm size
        $header->tag(1016) # group
    );
    return 1;
}

# is this usefull
# @keeptags can/should be reworks
sub light {
    my ($header) = @_;

    my $hlight = $header->copy();

    my @keeptags = (1000, 1001, 1002, 1003, 1004, 1009, 1016, 1021, 1022, 1044, 1047, 1048, 1049, 1050,
        1053, 1054, 1055, 1090, 1112, 1113, 1114, 1115, 1116, 1117, 1118);

    my @existing_tags = $hlight->listtag();
    foreach (@existing_tags) {
        grep($_, @keeptags) or $hlight->removetag($_);
    }
    $hlight
}

1;
